/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2008 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.tools.webadmin.datacollector.client.service;

import org.ow2.petals.jmx.PetalsJMXClient;
import org.ow2.petals.tools.webadmin.datacollector.client.exception.DataCollectorClientException;

/**
 * @author mcarpentier - EBM WebSourcing
 * 
 * Any data collector client service should extends this class
 * 
 */
public abstract class CollectorService {

    private final PetalsJMXClient petalsJMXClient;

    public CollectorService(PetalsJMXClient petalsJMXClient) {
        this.petalsJMXClient = petalsJMXClient;
    }

    public PetalsJMXClient getPetalsJMXClient() throws DataCollectorClientException {
        if (this.petalsJMXClient != null) {
            return petalsJMXClient;
        }
        else {
            throw new DataCollectorClientException("PEtALS connection lost");
        }
    }

}
