/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2008 EBM WebSourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.tools.webadmin.datacollector.dao.queues;

import java.util.List;

import org.hibernate.Session;
import org.ow2.petals.tools.webadmin.datacollector.bo.queues.ComponentQueuesStatusSnapshot;
import org.ow2.petals.tools.webadmin.datacollector.dao.DAOException;
import org.ow2.petals.tools.webadmin.datacollector.dao.GenericDAO;
import org.ow2.petals.tools.webadmin.datacollector.util.StringHelper;

/**
 * @author mcarpentier
 * 
 */
public class ComponentQueuesStatusSnapshotDAO extends GenericDAO {

    private static ComponentQueuesStatusSnapshotDAO theInstance;

    private ComponentQueuesStatusSnapshotDAO() {

    }

    public static synchronized ComponentQueuesStatusSnapshotDAO getInstance() {
        if (null == ComponentQueuesStatusSnapshotDAO.theInstance) {
            ComponentQueuesStatusSnapshotDAO.theInstance = new ComponentQueuesStatusSnapshotDAO();
        }
        return ComponentQueuesStatusSnapshotDAO.theInstance;
    }

    /**
     * @param session
     *            the hibernate session
     * @param server
     *            the petals server of the queues
     * @param component
     *            the component of the queues
     * @return
     * @throws DAOException
     */
    @SuppressWarnings("unchecked")
    public List<ComponentQueuesStatusSnapshot> retrieveByServerAndComponent(Session session,
            String server, String component) throws DAOException {
        if ((StringHelper.isNotNullAndNotEmpty(server))
                && (StringHelper.isNotNullAndNotEmpty(component))) {
            try {
                final String query = "from ComponentQueuesStatusSnapshot where server ='"
                        + server + "' and component='" + component + "'";
                return (List<ComponentQueuesStatusSnapshot>)session.createQuery(query).list();
            } catch (final Exception e) {
                throw new DAOException(
                        "Error retrieving ComponentQueuesStatusSnapshot using server :" + server
                                + " and component :" + component, e);
            }
        }
        throw new DAOException("bad request parameters");
    }
}
